-- Testbench shell that generates a clock signal
library IEEE;
use IEEE.Std_logic_1164.all;
use IEEE.Numeric_Std.all;

entity clocked_test is end;

architecture test_bench of clocked_test is
	-- Component/type/signal/etc decleration region
	
	-- Change this to specify whatever clock period
	-- you want to have
	constant clock_period: time := 40 ns;
	
	signal clock, Reset : std_logic;

	signal sim_end : std_logic := '0';

begin
	-- Instantiate DUT Component Here...

	test_process : process
	begin

		-- Give Design a Reset
		Reset <= '1';
		wait for 8 ns;
		Reset <= '0';
		wait for 14 ns;
    
		-- Place input test vectors here
		-- To seperate vectors with clock periods or half 
		-- clock periods, seperate with a full clock period...
		wait for clock_period;
		-- OR with a half clock period...
		wait for clock_period / 2;		
    
    		-- Set "sim_end" signal high to halt clock process
		sim_end <= '1';
		
		-- Halt this process
		wait;
	end process test_process ;

	clock_process: process
	begin

		clock <= '0';
		wait for clock_period / 2;

		clock <= '1';
		wait for clock_period / 2;

		if(sim_end = '1') then
			wait;
		end if;

	end process clock_process;

end test_bench;